/*
 * dmatrix.c
 */

#include <stdlib.h>
#include "matrix.h"

dmatrix new_dmatrix(int nrow, int ncol)
{
    int i;
    dvector ap;
    dmatrix a;

    if ((a = malloc(nrow * sizeof(dvector))) == NULL)
	    return NULL;
    if ((ap = malloc(nrow * ncol * sizeof(double))) == NULL) {
	free(a);
	return NULL;
    }
    for (i = 0; i < nrow; i++)
        a[i] = ap + (i * ncol);
    return a;
}

void free_dmatrix(dmatrix a)
{
    free(a[0]);
    free(a);
}
