/*
 * fdotprod.c
 */

#include "matrix.h"

double fdotprod(int n, fvector u, fvector v)
{
    int i, n4;
    double s;

    s = 0;
    n4 = n & 3; /* n % 4 */
    for (i = 0; i < n4; i++)
        s += u[i] * v[i];
    for (i = n4; i < n; i += 4)
        s += u[i] * v[i] + u[i + 1] * v[i + 1]
		 + u[i + 2] * v[i + 2] + u[i + 3] * v[i + 3];
    return s;
}
