/*
 * fmatrix.c
 */

#include "matrix.h"

fmatrix new_fmatrix(int nrow, int ncol)
{
    int i;
    fvector ap;
    fmatrix a;

    if ((a = malloc(nrow * sizeof(fvector))) == NULL)
	    return NULL;
    if ((ap = malloc(nrow * ncol * sizeof(float))) == NULL) {
	free(a);
	return NULL;
    }
    for (i = 0; i < nrow; i++)
        a[i] = ap + (i * ncol);
    return a;
}

void free_fmatrix(fmatrix a)
{
    free(a[0]);
    free(a);
}
