/*
 * imatrix.c
 */

#include <stdlib.h>
#include "matrix.h"

imatrix new_imatrix(int nrow, int ncol)
{
    int i;
    ivector ap;
    imatrix a;

    if ((a = malloc(nrow * sizeof(ivector))) == NULL)
	    return NULL;
    if ((ap = malloc(nrow * ncol * sizeof(int))) == NULL) {
	free(a);
	return NULL;
    }
    for (i = 0; i < nrow; i++)
        a[i] = ap + (i * ncol);
    return a;
}

void free_imatrix(imatrix a)
{
    free(a[0]);
    free(a);
}
