/*
 * matrix.c
 */

#include <stdlib.h>
#include "matrix.h"

matrix new_matrix(int nrow, int ncol)
{
    int i;
    vector ap;
    matrix a;

    if ((a = malloc(nrow * sizeof(vector))) == NULL)
        return NULL;
    if ((ap = malloc(nrow * ncol * sizeof(scalar))) == NULL) {
        free(a);
        return NULL;
    }
    for (i = 0; i < nrow; i++)
        a[i] = ap + (i * ncol);
    return a;
}

void free_matrix(matrix a)
{
    free(a[0]);
    free(a);
}
